﻿local Cartographer = Cartographer
local revision = tonumber(("$Revision: 27829 $"):sub(12, -3))
if revision > Cartographer.revision then
	Cartographer.version = "r" .. revision
	Cartographer.revision = revision
	Cartographer.date = ("$Date: 2007-02-11 21:50:20 -0500 (Sun, 11 Feb 2007) $"):sub(8, 17)
end

local L = AceLibrary("AceLocale-2.2"):new("Cartographer-Waypoints")

L:RegisterTranslations("enUS", function() return {
	["Waypoints"] = true,
	["Module which shows an arrow to direct you to a specified note or location."] = true,
	["Hint: /waypoint is available to create waypoints with the command line."] = true,
	["Guildmember %s not found."] = true,
	["No party member %s found."] = true,
	["Setting %s as waypoint."] = true,
	["Guildmember no longer locatable"] = true,
	["No matching note in zone: %s"] = true,
	["Invalid note entry."] = true,
	["Waypoints cleared."] = true,
	["Waypoint set: %s %.1f,%.1f"] = true,
	["For usage, see '/waypoint help'"] = true,
	["Commands are:"] = true,
	["General: /waypoint [add] <notesearch> OR <0-100>,<0-100> [title] OR g-<guildnamesearch> OR p-<partynamesearch>"] = true,
	["Clear  : /noway"] = true,
	["View   : /wayq"] = true,
	["Move to end of queue"] = true,
	
	["Console-waypoint-commands"] = {"/way", "/waypoint" },
	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = true,
	["Clear waypoint"] = true,
	["here"] = true,
	["Waypoint Marker"] = true,
	["No target found."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Waypoints"] = "위치 포인트",
	["Module which shows an arrow to direct you to a specified note or location."] = "당신이 작성한 노트나 위치를 화살표로 안내하는 모듈입니다.",
	["Hint: /waypoint is available to create waypoints with the command line."] = "힌트: 명령어로 위치 포인트를 새로 만들기 위해 /waypoint를 이용할 수 있습니다.",
--	["Guildmember %s not found."] = true,
--	["No party member %s found."] = true,
--	["Setting %s as waypoint."] = true,
--	["Guildmember no longer locatable"] = true,
--	["No matching note in zone: %s"] = true,
--	["Invalid note entry."] = true,
	["Waypoints cleared."] = "위치 포인트 제거",
	["Waypoint set: %s %.1f,%.1f"] = "위치 설정: %s %.1f,%.1f",
--	["For usage, see '/waypoint help'"] = true,
--	["Commands are:"] = true,
--	["General: /waypoint [add] <notesearch> OR <0-100>,<0-100> [title] OR g-<guildnamesearch> OR p-<partynamesearch>"] = true,
--	["Clear  : /noway"] = true,
--	["View   : /wayq"] = true,
--	["Move to end of queue"] = true,

--	["Console-waypoint-commands"] = {"/way", "/waypoint" },
--	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
--	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = "(%d+.?%d*)[, ](%d+.?%d*) ?(.*)",
	["Clear waypoint"] = "위치 포인트 삭제",
	["here"] = "여기",
	["Waypoint Marker"] = "위치 포인트 기록",
	["No target found."] = "대상을 찾을 수 없습니다.",
} end)

L:RegisterTranslations("deDE", function() return {
	["Waypoints"] = "Wegpunkte",
	["Module which shows an arrow to direct you to a specified note or location."] = "Modul das einen Pfeil anzeigt der dich zu einer Notiz oder Position führt.",
	["Hint: /waypoint is available to create waypoints with the command line."] = "Hinweis: /waypoint ist verfügbar um Wegpunkte zu erstellen auf Chat Kommando Basis.",
	["Guildmember %s not found."] = "Gildenmitglied %s nicht gefunden.",
	["No party member %s found."] = "Gruppenmitglied %s nicht gefunden.",
	["Setting %s as waypoint."] = "Setze %s als Wegpunkt.",
	["Guildmember no longer locatable"] = "Gildenmitglied nicht länger auffindbar",
	["No matching note in zone: %s"] = "Keine gültige Notiz in zone: %s",
	["Invalid note entry."] = "Ungültiger Notiz Eintrag.",
	["Waypoints cleared."] = "Wegpunkte entfernt",
	["Waypoint set: %s %.1f,%.1f"] = "Wegpunkte gesetzt: %s %.1f,%.1f",
	["For usage, see '/waypoint help'"] = "Für Beschreibung, benutze '/waypoint help'",
	["Commands are:"] = "Kommandos sind:",
	["General: /waypoint [add] <notesearch> OR <0-100>,<0-100> [title] OR g-<guildnamesearch> OR p-<partynamesearch>"] = "Allgemein: /waypoint [dazu] <notizsuche> ODER <0-100>,<0-100> [titel] ODER g-<gildennamenssuche> ODER p-<gruppennamenssuche>",
	["Clear  : /noway"] = "Entfernen  : /noway",
	["View   : /wayq"] = "Ansehen   : /wayq",
	["Move to end of queue"] = "Zum Ende der Warteschlange bewegen.",
	
	["Console-waypoint-commands"] = {"/way", "/waypoint" },
	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = "(%d+.?%d*)[, ](%d+.?%d*) ?(.*)",
	["Clear waypoint"] = "Entferne Wegpunkt",
	["here"] = "hier",
	["Waypoint Marker"] = "Wegpunkt Markierung",
	["No target found."] = "Kein Ziel gefunden.",
} end)

L:RegisterTranslations("frFR", function() return {
--	["Waypoints"] = true,
--	["Module which shows an arrow to direct you to a specified note or location."] = true,
--	["Hint: /waypoint is available to create waypoints with the command line."] = true,

--	["Waypoint cleared."] = true,
--	["Waypoint set: %s %.1f,%.1f"] = true,
--	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title]"] = true,
--	["Console-waypoint-commands"] = {"/way", "/waypoint" },
--	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
--	["Clear waypoint"] = true,
} end)

L:RegisterTranslations("esES", function() return {
--	["Waypoints"] = true,
--	["Module which shows an arrow to direct you to a specified note or location."] = true,
--	["Hint: /waypoint is available to create waypoints with the command line."] = true,
--	
--	["Waypoint cleared."] = true,
--	["Waypoint set: %s %.1f,%.1f"] = true,
--	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title]"] = true,
--	["Console-waypoint-commands"] = {"/way", "/waypoint" },
--	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
--	["Clear waypoint"] = true,
} end)

L:RegisterTranslations("zhTW", function() return {
--	["Waypoints"] = true,
--	["Module which shows an arrow to direct you to a specified note or location."] = true,
--	["Hint: /waypoint is available to create waypoints with the command line."] = true,
--
--	["Waypoint cleared."] = true,
--	["Waypoint set: %s %.1f,%.1f"] = true,
--	["Usage: /waypoint <search text> OR <0-100>,<0-100> [title]"] = true,
--	["Console-waypoint-commands"] = {"/way", "/waypoint" },
--	["Console-temp-waypoint-commands"] = {"/tway", "/tloc" },
--	["(%d+.?%d*)[, ](%d+.?%d*) ?(.*)"] = true,
--	["Clear waypoint"] = true,
} end)

Cartographer_Waypoints = Cartographer:NewModule("Waypoints", "AceHook-2.1", "AceEvent-2.0", "AceComm-2.0", "AceConsole-2.0")
local Cartographer_Waypoints = Cartographer_Waypoints
local self = Cartographer_Waypoints

local Dewdrop = AceLibrary("Dewdrop-2.0")
local Tablet = AceLibrary("Tablet-2.0")
local Tourist = AceLibrary("Tourist-2.0")
local Crayon = AceLibrary("Crayon-2.0")
local BZ = AceLibrary("Babble-Zone-2.2")
local RollCall = AceLibrary("RollCall-1.0")

local _G = getfenv(0)
local metric = GetLocale() ~= "enUS"

local yardString = GetLocale() == "enUS" and "%.0f yd" or "%.0f m"

local math_floor = math.floor

local playerModel

Queue = {}

local function round(num, digits)
	-- banker's rounding
	local mantissa = 10^digits
	local norm = num*mantissa
	norm = norm + 0.5
	local norm_f = math_floor(norm)
	if norm == norm_f and (norm_f % 2) ~= 0 then
		return (norm_f-1)/mantissa
	end
	return norm_f/mantissa
end

local function getID(x, y)
	return round(x*10000, 0) + round(y*10000, 0)*10001
end
Cartographer_Waypoints.getID = getID

local function getXY(id)
	return (id % 10001)/10000, math_floor(id / 10001)/10000
end
Cartographer_Waypoints.getXY = getXY

local delimiters = {[" "] = true, [","] = true, ["-"]=true}

-- I apologise for this function. It works, but it isn't pretty.
-- Just take it for granted that it explodes on the delimiter, but
-- takes into account quotation marks, as long as the quotation marks
-- are around more than one word.
function explode(...)
	
	if select("#",...) == 2 and delimiters[select(1,...)] then
		return explode(string.split(select(1, ...), select(2, ...)))
	end

	local arr,quote = {},nil
	for i = 1,select("#",...) do -- for each divider found
		local word = select(i,...)
		local quotefound = string.find(word,"[\"\']")
		if (not quotefound and not quote) or (quotefound and quote) then
			if quotefound and quote then
				table.insert(arr, quote.." "..word)
			else
				table.insert(arr,word)
			end
			quote = nil
		else
			if quote then 
				quote = quote.." "..word
			else
				quote = word
			end
		end
	end
	return arr
end

function Cartographer_Waypoints:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("Waypoints")
	
	Cartographer:RegisterDefaults("Waypoints", "profile", {
		showYardsAway = true,
		waypointQueue = {},
	})

	self.name = L["Waypoints"]
	self.title = L["Waypoints"]
	Cartographer.options.args.Waypoints = {
		name = L["Waypoints"],
		desc = L["Module which shows an arrow to direct you to a specified note or location."], 
		type = 'group',
		args = {
			toggle = {
				name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
				desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
				type = "toggle",
				order = -1,
				get = function() return Cartographer:IsModuleActive(self) end,
				set = function() Cartographer:ToggleModuleActive(self) end
			},
		},
		handler = self,
	}
end

local waypointFrame
local waypointLocalZone

local function createWaypointFrame()
	path = debugstack(1, 1, 0)
	if path:find("grapher\\") then
		path = "Interface\\AddOns\\Cartographer\\Cartographer_Waypoints\\Artwork\\Arrow"
	elseif path:find("grapher_Waypoints\\") then
		path = "Interface\\AddOns\\Cartographer_Waypoints\\Artwork\\Arrow"
	else
		error("Cannot determine path of artwork")
	end

	waypointFrame = CreateFrame("Frame", "Cartographer_Waypoint", UIParent)
	waypointFrame:SetWidth(56)
	waypointFrame:SetHeight(64)
	waypointFrame:Show()
	local tex = waypointFrame:CreateTexture(nil, "OVERLAY")
	waypointFrame.tex = tex
	tex:SetWidth(56)
	tex:SetHeight(42)
	tex:SetTexture(path)
	waypointFrame.up = false
	tex:SetPoint("TOP")
	local dist = waypointFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	waypointFrame.dist = dist
	dist:SetPoint("BOTTOM")
	local title = waypointFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	waypointFrame.title = title
	title:SetPoint("TOP", waypointFrame, "BOTTOM")
	waypointFrame:EnableMouse(true)
	waypointFrame:SetMovable(true)
	waypointFrame:RegisterForDrag("LeftButton")
	waypointFrame:SetScript("OnDragStart", function(this)
		this:StartMoving()
	end)
	waypointFrame:SetScript("OnDragStop", function(this)
	this:StopMovingOrSizing()
		local x,y = this:GetCenter()
		x = x - GetScreenWidth() / 2
		y = y - GetScreenHeight() / 2
		self.db.profile.waypointX = x
		self.db.profile.waypointY = y
		this:ClearAllPoints()
		this:SetPoint("CENTER", UIParent, "CENTER", x, y)
	end)
	waypointFrame:SetClampedToScreen(true)
	waypointFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.waypointX, self.db.profile.waypointY)
	Dewdrop:Register(waypointFrame,
		'children', function()
			Dewdrop:AddLine(
				'text', L["Clear waypoint"],
				'arg1', self,
				'arg2', Queue,
				'func', function(self, Queue) Queue[1]:Cancel() end,
				'closeWhenClicked', true
			)
			Dewdrop:AddLine(
				'text', L["Move to end of queue"],
				'arg1', self,
				'arg2', Queue,
				'func', function(self, Queue) table.insert(Queue, table.remove(Queue, 1)) end,
				'closeWhenClicked', true
			)
			Dewdrop:AddLine()
			Dewdrop:AddLine(
				'text', CLOSE,
				'closeWhenClicked', true
			)
		end
	)
end
function Cartographer_Waypoints:OnEnable()
		
	self:RegisterEvent("RollCall10_MemberDisconnected")
	self:RegisterComm("Cartographer_GuildPositions", "GUILD")
	self:RegisterEvent("Cartographer_MapOpened")
	self:RegisterEvent("Cartographer_MapClosed")
	
	local DEFAULT_MIN_DIST = 30

	local function waypointCommand(text,temp)
		local waypoint

		if not text or string.len(text) < 1 then
			self:Print(L["For usage, see '/waypoint help'"])
			return
		end
		if text == "help" then
			self:Print(L["Commands are:"])
			self:Print(L["General: /waypoint [add] <notesearch> OR <0-100>,<0-100> [title] OR g-<guildnamesearch> OR p-<partynamesearch>"])
			self:Print(L["Clear  : /noway"])
			self:Print(L["View   : /wayq"])
			return
		end

		SetMapToCurrentZone()
		local zone = Cartographer:GetCurrentEnglishZoneName()

		-- This function will take the explode by delimiter and then further explode
		-- each entry by '-' and then insert them into a table
		-- For an argument string like 'Cabbage p-Womble z-Zangarmarsh Frogs" you'll end 
		-- up with a table looking like:
		-- { 
		--   arg1 = "Cabbage",
		--   p = "Womble",
		--   z = "Zangarmarsh",
		--   arg2 = "Frogs"
		-- }
		-- 
		local function parseOptions(text, delimiter)
			if not delimiter then delimiter = " " end
			local args, options, count = explode(delimiter, text), {}, 1
			for _, arg in ipairs(args) do
				local split = explode("-", arg)
				if #split == 2 then
					options[split[1]] = split[2]
				else
					options["arg"..count] = arg
					count = count + 1
				end
			end
			return options
		end
		-- The options we have in place are:
		--		g-<GuildMemberNameOrPartThereof>
		--		p-<PartyMemberNameOrPartThereof>
		--		z-<SpecificZoneName>
		--
		options = parseOptions(text)
		womble = options
		local x,y,title
		-- Okay, horribly convoluted. 
		-- Basically we want to handle the following possiblities for note based waypoints
		--		/way 23,34
		--		/way add 23,34
		--		/way 23,34 MyNote
		--		/way add 23,34 MyNote
		--		/way CurrentNoteSearchName
		--		/way add CurrentNoteSearchName
		if options.arg1 then -- check for x,y
			local xy = explode(",", options.arg1)
			if #xy == 2 then
				x = xy[1]
				y = xy[2]
				if options.arg2 and type(options.arg2) == "string" then
					title = options.arg2
				else
					title = "Waypoint"
				end
			else
				if options.arg1 == "add" then
					if options.arg2 then
						xy = explode(",", options.arg2)
						if #xy == 2 then
							x = xy[1]
							y = xy[2]
						else -- We're a text search for a note, not a x,y note
							x, y = select(2,Cartographer_Notes:FindNearestNote(options.arg2, options.z))
							if not x then
								self:Print(L["No matching note in zone: %s"], options.z or zone)
								return
							end
						end
						if options.arg3 and type(options.arg3) == "string" then
							title = options.arg3
						else
							title = "Waypoint"
						end
					end
				else 
					x, y = select(2, Cartographer_Notes:FindNearestNote(options.arg1, options.z))
					if not x then
						self:Print(L["No matching note in zone: %s"], options.z or zone)
						return
					end
				end
			end
			if x > 1 and y > 1 then
				x,y = x/100, y/100
			end
			waypoint = NotePoint:new(zone, x, y, title)
			if not waypoint:IsValid() then
				self:Print(L["Invalid note entry."])
				return
			end
		end

		if options.g then -- We want to add a guild member
			waypoint = GuildPoint:new(options.g)
			if not waypoint:IsValid() then
				self:Print(L["Guildmember %s not found."], options.g)
				return
			end
		end

		if options.p then -- We want to add a party member
			waypoint = PartyPoint:new(options.p)
			if not waypoint:IsValid() then
				self:Print(L["No party member %s found."], options.p)
				return
			end
		end
		
		if options.arg1 and options.arg1 == "add" then
			table.insert(Queue, waypoint)
		else
			table.insert(Queue, 1, waypoint)
		end
		
		self:ScheduleRepeatingEvent("CartographerWaypoints-UpdateWaypoint", self.UpdateWaypoint, 0.05, self)
		if not waypointFrame then
			createWaypointFrame()
		end

	end
	local function getQueue()
		self:Print("Waypoint Queue:")
		for i,v in ipairs(Queue) do
			self:Print("    "..v:ToString())
		end
	end
	
	self:RegisterChatCommand(L["Console-waypoint-commands"],function(text)
		waypointCommand(text)
	end)
	
	self:RegisterChatCommand({"/wayq"}, function() getQueue() end)

	self:RegisterChatCommand({"/noway"},function()
		self:Print(L["Waypoints cleared."])
		for i,v in ipairs(Queue) do
			v:Cancel()
		end
		Queue = {}
	end)
	
	if not playerModel then
		local t = { Minimap:GetChildren() }
		for i = #t, 1, -1 do
			local v = t[i]
			if v:GetObjectType() == "Model" and not v:GetName() then
				playerModel = v
				break
			end
		end
	end
end



function Cartographer_Waypoints:ZONE_CHANGED_NEW_AREA()
	self:ScheduleRepeatingEvent("CartographerWaypoints-UpdateWaypoint", self.UpdateWaypoint, 0.05, self)
end

function Cartographer_Waypoints:GetWaypoint()
	if Queue[1] then
		local waypointNote= Queue[1]
		return waypointNote.zone, waypointNote.x, waypointNote.y
	else
		return nil
	end
end

function Cartographer_Waypoints:IsNoteWaypoint(zone, id)
	AceLibrary.argCheck(self, zone, 2, "string", "nil")
	if zone then
		if Queue[1] then
			return Queue[1]:MatchNote(zone, id)
		else
			return false
		end
	end
end


function Cartographer_Waypoints:Cartographer_MapOpened()
	if Queue[1] then
		self:CancelScheduledEvent("CartographerWaypoints-UpdateWaypoint")
		waypointFrame.dist:SetText("-")
	end
end
function Cartographer_Waypoints:Cartographer_MapClosed()
	if Queue[1] then
		self:ScheduleRepeatingEvent("CartographerWaypoints-UpdateWaypoint", self.UpdateWaypoint, 0.05, self)
	end
end

	
local _54_div_math_pi = 54/math.pi
local math_rad_90 = math.rad(90)
local math_atan2 = math.atan2
local math_floor = math.floor
local count = 53
function Cartographer_Waypoints:UpdateWaypoint()
	local realZoneText = GetRealZoneText()
	local px, py = Cartographer:GetCurrentPlayerPosition()
	local waypoint = Queue[1]
	
	if not waypoint then
		self:CancelScheduledEvent("CartographerWaypoints-UpdateWaypoint")
		waypointFrame:Hide()
		return
	end
	
	if not waypoint:IsValid() then
		self:Print("Clearing up queue")
		table.remove(Queue, 1):Cancel()
		waypoint = Queue[1]
		return
	end
	
	
	if not waypointFrame:IsShown() then
		waypointFrame:Show()
	end
	
	local dist = waypoint:GetDistance()
	if not dist then
		dist = 0
	end
	if dist <= 5 and waypoint:IsReady() then 
		if #Queue == 0 then
			waypointFrame:Hide()
		else
			table.remove(Queue, 1):Cancel()
			return
		end
		self:TriggerEvent("CartographerWaypoints_WaypointHit",waypoint)
	end
	
	if dist <=10 then
		if not waypointFrame.up then
			waypointFrame.tex:SetTexture("Interface\\AddOns\\Cartographer\\Cartographer_Waypoints\\Artwork\\Arrow-UP")
			waypointFrame.tex:SetWidth(53)
			waypointFrame.tex:SetHeight(70)
			waypointFrame.up = true
		end
	else
		if waypointFrame.up then
			waypointFrame.tex:SetTexture("Interface\\AddOns\\Cartographer\\Cartographer_Waypoints\\Artwork\\Arrow")
			waypointFrame.tex:SetWidth(56)
			waypointFrame.tex:SetHeight(42)
			waypointFrame.up = false
		end
	end
	local x,y = Tourist:TransposeZoneCoordinate(waypoint.x, waypoint.y, waypoint.Zone, realZoneText)

	if waypoint:IsReady() then 
		if not waypointFrame.up then
			local diffX, diffY = x - px, y - py
			local rad = -math_atan2(diffY*2/3, diffX)
			local direction = playerModel:GetFacing() + math_rad_90 
			local val = ((rad - direction)*_54_div_math_pi + 108) % 108
			local col, row = math_floor(val % 9), math_floor(val / 9)
			waypointFrame.tex:SetTexCoord(col*56/512, (col+1)*56/512, row*42/512, (row+1)*42/512)
		else
			count = count + 1
			if count == 54 then
				count = 0
			end
			local col, row = math_floor(count % 9), math_floor(count / 9)
			waypointFrame.tex:SetTexCoord(col*53/512, (col+1)*53/512, row*70/512, (row+1)*70/512)
		end
		waypointFrame.tex:SetVertexColor(Crayon:GetThresholdColorTrivial(dist, 1000, 300, 100, 30, 0))
	else
		waypointFrame.tex:SetTexCoord(0, 0, 0, 0)
		waypointFrame.tex:SetVertexColor(Crayon.COLOR_HEX_SILVER)
	end	
	waypointFrame.dist:SetText(yardString:format(dist))
	waypointFrame.title:SetText(waypoint:ToString())
end

function Cartographer_Waypoints:OnProfileEnable()
	self:RefreshMap()
	if waypointFrame then
		waypointFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x, self.db.profile.y)
	end
end


Cartographer_Waypoints.OnCommReceive = {
	POSITION = function(self, prefix, sender, distribution, zone, _x, _y)
		if(GuildPoint.Watcher[sender] and #Queue > 0 and Queue[1].WaypointID == sender) then
			GuildPoint.Watcher[sender]:UpdateLocation(zone, _x, _y)
		end
	end
}

function Cartographer_Waypoints:RollCall10_MemberDisconnected(memberName)
	if GuildPoint.Watcher[memberName] then
		GuildPoint.Watcher[memberName]:Cancel()
	end
end

function Cartographer_Waypoints:RosterLib_UnitChanged(...)
	if select(6,...) and select(1, ...) then
		local party = PartyPoint.Roster[select(6, ...)]
		PartyPoint.Roster[select(1, ...)] = party
		party.PartyID = select(1, ...)
	end

	if not select(1, ...) then
		PartyPoint.Roster[select(6, ...)]:Cancel();
	end
end
-- Now for the attempted GUI. I hate writing these

